diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/aextern.s v15.6301-amd64/pop/src/aextern.s
--- v15.63/pop/src/aextern.s	1996-08-09 12:25:22.000000000 -0400
+++ v15.6301-amd64/pop/src/aextern.s	2010-01-03 05:55:39.000000000 -0500
@@ -13,8 +13,8 @@
 
 lconstant macro (
 
-	USP		= "ebx",	;;; User stack pointer
-	PB		= "ebp",	;;; Procedure base register
+	USP		= "rbx",	;;; User stack pointer
+	PB		= "rbp",	;;; Procedure base register
 
 	SAVED_SP	= [I_LAB(Sys$-Extern$- _saved_sp)],
 	SAVED_USP	= [I_LAB(Sys$-Extern$- _saved_usp)],
@@ -22,7 +22,7 @@
 	_BGI_LENGTH	= @@BGI_LENGTH,
 	_BGI_SLICES	= @@BGI_SLICES,
 	_DD_1		= @@DD_1,	;;; MS half of ddecimal
-	_DD_2		= @@DD_2,	;;; LS half of ddecimal
+;;;	_DD_2		= @@DD_2,	;;; LS half of ddecimal
 	_EFC_FUNC	= @@EFC_FUNC,
 	_EFC_ARG	= @@EFC_ARG,
 	_EFC_ARG_DEST	= @@EFC_ARG_DEST,
@@ -61,15 +61,7 @@
 ;;;	Results are returned in the three-word structure result_struct
 ;;;	double float result first, followed by a single word result.
 ;;;	Must be capable of dealing with callback.
-
-;;; Register usage:
-;;;	EAX	argument conversion; result from the external call
-;;;	ECX	number of arguments (_____nargs);
-;;;		address of result array
-;;;	EDX	_________fltsingle bit mask
-;;;	ESI	external type of compound arguments
-;;;	EDI	address of the external routine (_______routine)
-
+;;;
 ;;; Memory usage:
 ;;;	SAVED_SP
 ;;;		pointer to the stack frame of the calling procedure;
@@ -83,156 +75,271 @@
 ;;;             (on systems without mprotect) remembers the current
 ;;;             break in case the external routine allocates extra store
 
-DEF_C_LAB (_call_external)
+;;;    Registers: 
+;;;       %rdi, %rsi, %rdx, %rcx, %r8, %r9   -- integer arguments
+;;;       %xmm0 to %xmm5                     -- floating point arguments
+;;;
+;;;       %rax   --  work register, external type of compound arguments
+;;;                  number of floating point arguments in registers
+;;;                  at call
+;;;       %rbp   --  frame pointer
+;;;       %r10   --  work register2, external type of compound arguments
+;;;                  during conversion
+;;;                  routne at call
+;;;       %r11   --  floating point argument store routine
+;;;       %r12   --  fltsingle
+;;;       %r13   --  integer argument store routine
+;;;       %r14   --  displacement on machine (control) stack
+;;;       %r15   --  displacement on Poplog (user) stack
+;;;
+;;;    Work variables on the machine stack:
+;;;       -16(%rbp)  -- saved rountine
+;;;       -24(%rbp)  -- work variable for memory conversion
+;;;       -32(%rbp)  -- number of floating point arguments in registers
+;;;                     during conversion
+
+  .text
+
+;;; Functions to store arguments, use macros to save on repetition
+#_<
+lvars ci = 0;
+define lconstant macro gen_storei;
+        lvars x y;
+        itemread() -> x;
+        itemread() -> y;
+'int_arg' >< ci >< ':\n';
+ ci + 1 -> ci;
+        '\tmovq %rax', ",", '%' >< y, '\n';
+        '\tmovq $int_arg' >< ci, ', %r13\n';
+        '\tjmp next_arg\n\n';
+enddefine;
+define lconstant macro gen_storesf;
+  lvars cf = 0, cfn;
+  while cf < 6 do
+   cf + 1 -> cfn;
+'float_arg', >< cf, >< ':\n';
+  '\incl   -32(%rbp)\n';
+  '\tmovq  $float_arg', >< cfn, ',%r11\n';
+  '\ttestl   $1, %r12d\n';
+  '\tjnz single_', >< cf >< '\n';
+
+;;; just load the value
+
+  '\tmovlpd  -24(%rbp), %xmm' >< cf >< '\n';
+  '\tsarl $1, %r12d\n';
+  '\tjmp next_arg\n\n';
+
+;;; convert to single
+
+'single_', >< cf >< ':\n';
+  '\tcvtsd2ss   -24(%rbp), %xmm' >< cf >< '\n';
+  '\tsarl $1, %r12d\n';
+  '\tjmp next_arg\n\n';
+  cfn -> cf;
+  endwhile
+enddefine;
+>_#
+
+gen_storesf
 
+gen_storei rdi
+gen_storei rsi
+gen_storei rdx
+gen_storei rcx
+gen_storei r8
+gen_storei r9
+
+int_arg6:
+        movq %rax, (%rsp, %r14)
+        addq    $8, %r14
+        jmp next_arg
+
+float_arg6:
+        incl   -32(%rbp)
+        testl   $1, %r12d
+        jnz single_6
+        movq %rax, (%rsp, %r14)
+        addq    $8, %r14
+        sarl $1, %r12d
+        jmp next_arg
+
+single_6:
+        cvtsd2ss  -24(%rbp), %xmm7
+        movss   %xmm7, (%rsp, %r14)
+        addq    $8, %r14
+        sarl $1, %r12d
+        jmp next_arg
+
+
+DEF_C_LAB (_call_external)
 #_IF CHECK_BREAK
 
 	;;; Save the current break in case the external routine allocates
 	;;; its own dynamic memory.
 
-	movl	EXTERN_NAME(___brk_addr), %eax
-	movl	%eax, save_curbrk
+	movq	EXTERN_NAME(___brk_addr), %rax
+	movq	%rax, save_curbrk
 
 #_ENDIF
 
 	;;; Save caller's stack pointer for interrupt/callback
 
-	leal	4(%esp), %eax
-	movl	%eax, SAVED_SP
+	leaq	8(%rsp), %rbp
+	movq	%rbp, SAVED_SP
+
+        ;;; save registers.  XXXX What to do about garbage collection
+        ;;; of Pop values ???
+        push    %r8
+        push    %r10
+        push    %r11
+        push    %r12
+        push    %r13
+        push    %r14
+        push    %r15
 
 	;;; Load fixed arguments
 
-	movl	(%USP), %edx	;;; _________fltsingle
-	movl	4(%USP), %edi	;;; _______routine
-	movl	8(%USP), %ecx	;;; _____nargs
-	addl	$12, %USP
-
-	testl	%ecx, %ecx
-	jz	do_call
-
-	;;; Rotate _________fltsingle to get bit for last arg at the top
-
-	cmpl	$32, %ecx
-	jae	argloop
-	rorl	%cl, %edx
+	movq	(%USP), %r12	;;; _________fltsingle
+	movq	8(%USP), %r10	;;; _______routine
+	movq	16(%USP), %r15	;;; _____nargs
+        shlq    $3, %r15        ;;; convert ot byte offset;
+	leaq	24(%USP), %USP  ;;; adjust user stack
+        xorl    %eax,%eax
+	testq	%r15, %r15
+        jz      do_call1
+
+;;;     We need 4 words on stack as a workplace     
+;;;     In the worst case, when we have one argument (which always
+;;;     fits into a register this gives 3+nargs, push allocate 1
+;;;     so we put another two into alignment code
+
+        subq    $56, %rbp
+        push    %r10
+        xorq    %r14, %r14
+        subq    %r15, %rsp       ;;; allocate space for arguments
+        subq    $0x16, %rsp        ;;; 
+        andq    $-0xf0, %rsp       ;;; align the stack
+        movl    $0, -32(%rbp)
+        movq   %r15, -40(%rbp)
+
+        movq   $int_arg0,   %r13
+        movq   $float_arg0, %r11  
 
 	;;; Transfer (and convert) any arguments
 
+
 argloop:
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	-8(%USP, %r15), %rax
 
-	testl	$1, %eax	;;; issimple
+	testq	$1, %rax	;;; issimple
 	jz	L2.1
-	testl	$2, %eax	;;; isinteger
-	jz	L1.1
-
-	;;; Pop integer: convert to m/c integer and push
-
-	sarl	$2, %eax
-	pushl	%eax
-	jmp	nextarg
-
-L1.1:	;;; Pop decimal: convert to m/c single float and push
-
-	subl	$1, %eax
-	pushl	%eax
-
-	;;; If the sign bit of _________fltsingle is not set, convert to double
-
-	testl	%edx, %edx
-	js	nextarg
-	flds	(%esp)		;;; Load from stack as single
-	subl	$4, %esp
-	fstpl	(%esp)		;;; Store back as double
-	jmp	nextarg
+	testq	$2, %rax	;;; isinteger
+        jz      L1.1
+ 
+	;;; Pop integer: convert to m/c integer and call store
+        ;;;   routine
+
+	sarq	$2, %rax
+	jmp     *%r13
+
+L1.1:	;;; Pop decimal: store in memory for conversionconvert to m/c single float and push
+
+	subq	$1, %rax
+	movq    %rax, -24(%rbp)
+        ;;;  call conversion & store
+        jmp     *%r11        
 
 L2.1:	;;; Pop structure: get extern type from key into ESI
 
-	movl	_KEY(%eax), %esi
-	movzbl	_K_EXTERN_TYPE(%esi), %esi
+	movq	_KEY(%rax), %r10
+	movzbl	_K_EXTERN_TYPE(%r10), %r10d
 
-	testl	%esi, %esi
+	testl	%r10d, %r10d
 	jnz	L3.1
 
 	;;; EXTERN_TYPE_NORMAL (0): push unchanged
 
-	pushl	%eax
-	jmp	nextarg
+        jmp     *%r13
 
-L3.1:	cmpl	$_:EXTERN_TYPE_DEREF, %esi
+L3.1:	cmpl	$_:EXTERN_TYPE_DEREF, %r10d
 	jne	L4.1
 
 	;;; External pointer: push dereferenced
 
-	pushl	_XP_PTR(%eax)
-	jmp	nextarg
+        movq    _XP_PTR(%rax), %rax
+        jmp     *%r13
 
-L4.1:	cmpl	$_:EXTERN_TYPE_DDEC, %esi
+L4.1:	cmpl	$_:EXTERN_TYPE_DDEC, %r10d
 	jne	L5.1
 
 	;;; Ddecimal: push the two halves
 
-	pushl	_DD_1(%eax)
-	pushl	_DD_2(%eax)
+        movq    _DD_1(%rax), %r10
+        movq    %r10, -24(%rbp)
+        jmp     *%r11
 
 	;;; If the sign bit of _________fltsingle is set, convert to single float
 
-	testl	%edx, %edx
-	jns	nextarg
-	fldl	(%esp)		;;; Load from stack as double
-	addl	$4, %esp
-	fstps	(%esp)		;;; Store back as single
-	jmp	nextarg
-
 L5.1:	;;; Must be biginteger: load first slice to ESI
 
-	movl	_BGI_SLICES(%eax), %esi
-
-	;;; If there's more than one slice, pull in the bottom bit of the
-	;;; second
+        ;;; If there's more than one slice, pull in the high bits first
 
-	cmpl	$1, _BGI_LENGTH(%eax)
+        cmpl    $3, _BGI_LENGTH(%rax)
+        jb      L5.2
+	movl	_BGI_SLICES+8(%rax), %r10d
+        shl     $62, %r10
+        ;;; spill to the stack
+        movq    %r10, -24(%rbp)
+        movl    _BGI_SLICES+4(%rax),%r10d
+        shlq    $31, %r10
+        movl    _BGI_SLICES(%rax), %eax
+        orq     %r10, %rax
+        orq     -24(%rbp), %rax
+        jmp     *%r13
+
+	;;; At most two slices, pull in the lowest part first
+L5.2:
+        movl    _BGI_SLICES(%rax), %r10d
+	cmpl	$1, _BGI_LENGTH(%rax)
 	je	L6.1
-	movl	_BGI_SLICES+4(%eax), %eax
-	shll	$1, %esi
-	shrdl	$1, %eax, %esi
+	movl	_BGI_SLICES+4(%rax), %eax
+	shrq	$1, %rax
+	orq     %r10, %rax
+        jmp     *%r13
 
 L6.1:	;;; Push the result
 
-	pushl	%esi
+	movq    %r10, %rax
+        jmp     *%r13
 
-nextarg:
+next_arg:
+        subq    $8, %r15
+        jnz     argloop
 
-	subl	$1, %ecx
-	jz	do_call
-
-	;;; Shift up _________fltsingle
-
-	cmpl	$32, %ecx
-	jae	argloop
-	shll	$1, %edx
-	jmp	argloop
+        addq    -40(%rbp), %USP
+        movq    -16(%rbp), %r10
 
 do_call:
-
+        movb    -32(%rbp), %al
+do_call1:
 	cld				;;; clear direction flag
-	movl	%USP, SAVED_USP	;;; save USP for callback
-	movl	%esp, EXTERN_NAME(__pop_in_user_extern)
+	movq	%USP, SAVED_USP	;;; save USP for callback
+	movq	%rsp, EXTERN_NAME(__pop_in_user_extern)
 					;;; enable async callback
-	call	*%edi
-	movl	$0, EXTERN_NAME(__pop_in_user_extern)
+	call	*%r10
+	movq	$0, EXTERN_NAME(__pop_in_user_extern)
 					;;; disable async callback
-	movl	SAVED_USP, %USP	;;; restore USP
+	movq	SAVED_USP, %USP	;;; restore USP
 
 	;;; Copy possible results into result_struct:
 	;;; double result from ST(0) first, then word result from EAX
 
-	leal	C_LAB(Sys$-Extern$-result_struct), %ecx
-
-	movl	%eax, 8(%ecx)		;;; word result
+	leaq	C_LAB(Sys$-Extern$-result_struct), %rcx
 
+	movq	%rax, 8(%rcx)		;;; word result
+        movq    %xmm0, (%rcx)           ;;; double result
+#_IF false
 	;;; See if there's a double result (i.e something in ST(0)):
 	;;; use FXAM, and copy the resulting status word to EAX.
 	;;; Mask out everything except bits C0 and C3; if these are both
@@ -245,19 +352,28 @@
 	je	L7.1
 
 	fstpl	(%ecx)			;;; double result
+#_ENDIF
 
 L7.1:	;;; Reset stack pointer
 
-	movl	SAVED_SP, %eax
-	leal	-4(%eax), %esp
-	movl	$0, SAVED_SP		;;; Indicates external call over
+	movq	SAVED_SP, %rax
+        movq    (%rax), %rbp
+        movq    -16(%rax), %r8
+        movq    -24(%rax), %r10
+        movq    -32(%rax), %r11
+        movq    -40(%rax), %r12
+        movq    -48(%rax), %r13
+        movq    -56(%rax), %r14
+        movq    -64(%rax), %r15
+	leaq	-8(%rax), %rsp
+	movq	$0, SAVED_SP		;;; Indicates external call over
 
 #_IF CHECK_BREAK
 
 	;;; Check for change in the break
 
-	movl 	save_curbrk, %eax
-	cmpl	%eax, EXTERN_NAME(___brk_addr)
+	movq 	save_curbrk, %rax
+	cmpq	%rax, EXTERN_NAME(___brk_addr)
 	je	L0.1
 	jmp	XC_LAB(Sys$-Mem_break_changed)
 
@@ -266,31 +382,43 @@
 L0.1:	ret
 
 
-	.align	4
+	.align  16
 
 
 ;;; _EXFUNC_CLOS_ACTION:
 ;;;	called from the code in an exfunc_closure (see asmout.p), with
-;;;	the top of stack pointing to (exfunc_clos address)+8
+;;;	the top of stack pointing to (exfunc_clos address)+10
 
-DEF_C_LAB(Sys$- _exfunc_clos_action)
+        .data
+mess2:
+        .string "untested _exfunc_clos_action called\\nlook in aextern.s to enable\\n"
+        .text
+_exfunc_clos_action_message:
 	;;; Load address of external closure record to eax
+        movq    $mess2, %rdi
+        movl    $0, %eax
+        call    printf
+        movl    $1, %edi
+        call    exit
 
-	popl	%eax
-	leal	-8(%eax), %eax
+DEF_C_LAB(Sys$- _exfunc_clos_action)
+        ;;; Comment out the jump to enable
+;;;        jmp _exfunc_clos_action_message
+	movq	(%rsp), %r11
+	leaq	-11(%r11), %r11
 
 	;;; Store frozen argument to destination
 
-	movl	_EFC_ARG_DEST(%eax), %edx
-	movl	_EFC_ARG(%eax), %ecx
-	movl	%ecx, (%edx)
+	movq	_EFC_ARG_DEST(%r11), %r10
+	movq	_EFC_ARG(%r11), %r11
+	movq	%r11, (%r10)
 
 	;;; Chain function via external ptr
 
-	movl	_EFC_FUNC(%eax), %eax
-	jmp	*(%eax)
-
-	.align	4
+        popq    %r11
+	movq	_EFC_FUNC-11(%r11), %r11
+	jmp	*(%r11)
+	.align  16
 
 
 ;;; _POP_EXTERNAL_CALLBACK:
@@ -302,56 +430,74 @@
 ;;; Arguments:
 ;;;	argp[0]	is the function code for -Callback-
 
+        .data
+mess3:
+        .string "untested _pop_external_callback called\\nlook in aextern.s to enable\\n"
+        .text
+_pop_external_callback_message:
+        ;;; Load address of external closure record to eax
+        movq    $mess3, %rdi
+        movl    $0, %eax
+        call    printf
+        movl    $1, %edi
+        call    exit
+        ;;; safety loop
+ sloop1:
+        jmp sloop1        
+
+;;; .globl  EXTERN_NAME(debug_pop)
+        
+
 .globl	EXTERN_NAME(_pop_external_callback)
 EXTERN_NAME(_pop_external_callback):
 	;;; for indirect weak reference
 DEF_C_LAB(Sys$- _external_callback_func)
-
-	;;; Save user registers
-
-	pushl	%ebx
-	pushl	%ebp
-	pushl	%esi
-	pushl	%edi
+;;;        jmp _pop_external_callback_message
+	;;; Save user registers      
+	pushq	%rbx
+	pushq	%rbp
+	pushq	%r12
+	pushq	%r13
+        pushq   %r14
+        pushq   %r15
 
 	;;; Save __pop_in_user_extern
 
-	pushl	EXTERN_NAME(__pop_in_user_extern)
+	pushq	EXTERN_NAME(__pop_in_user_extern)
 
 	;;; Create 3 word dummy stack frame for SF_NEXT_SEG_SP
 	;;; and SF_NEXT_SEG_HI
 
-	leal	-12(%esp), %esp
+	leaq	-24(%rsp), %rsp
 
 	;;; Disable async callback
 
-	movl	$0, EXTERN_NAME(__pop_in_user_extern)
+	movq	$0, EXTERN_NAME(__pop_in_user_extern)
 
 	;;; Restore procedure base register and saved USP
 
-	movl	SAVED_SP, %eax
-	movl	(%eax), %PB
-	movl	SAVED_USP, %USP
+	movq	SAVED_SP, %rax
+	movq	(%rax), %PB
+	movq	SAVED_USP, %USP
 
 	;;; Push argp
 
-	subl	$8, %USP
-	movl	36(%esp), %eax
-	movl	%eax, 4(%USP)
+	subq	$16, %USP
+	movq	%rdi, 8(%USP)
 
 #_IF CHECK_BREAK
 
 	;;; Push any change in the break
 
-	movl	save_curbrk, %eax
-	subl	EXTERN_NAME(___brk_addr), %eax
-	movl	%eax, (%USP)
+	movq	save_curbrk, %rax
+	subq	EXTERN_NAME(___brk_addr), %rax
+	movq	%rax, (%USP)
 
 #_ELSE
 
 	;;; No need to worry about the break: push a dummy argument
 
-	movl	$0, (%USP)
+	movq	$0, (%USP)
 
 #_ENDIF
 
@@ -363,50 +509,71 @@
 
 	;;; Resave current break
 
-	movl	EXTERN_NAME(___brk_addr), %eax
-	movl	%eax, save_curbrk
+	movq	EXTERN_NAME(___brk_addr), %rax
+	movq	%rax, save_curbrk
 
 #_ENDIF
 
 	;;; Return status code
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	(%USP), %rax
+	addq	$8, %USP
 
 	;;; Resave USP
 
-	movl	%USP, SAVED_USP
+	movq	%USP, SAVED_USP
 
 	;;; Remove stack frame
 
-	leal	12(%esp), %esp
+	leaq	24(%rsp), %rsp
 
 	;;; Re-enable async callback (restoring saved __pop_in_user_extern)
 
-	popl	EXTERN_NAME(__pop_in_user_extern)
+	popq	EXTERN_NAME(__pop_in_user_extern)
 
 	;;; Restore registers and return
 
 	cld
-	popl	%edi
-	popl	%esi
-	popl	%ebp
-	popl	%ebx
-
+        popq    %r15
+        popq    %r14
+	popq	%r13
+	popq	%r12
+	popq	%rbp
+	popq	%rbx
 	ret
 
-	.align	4
+	.align  16
 
 
+EXTERN_NAME(pop_print):
+#_IF CHECK_BREAK
+
+        ;;; Save the current break so that callback code has correct
+        ;;; info 
+
+        movq    EXTERN_NAME(___brk_addr), %rax
+        movq    %rax, save_curbrk
+        movl    $0, %eax
+#_ENDIF
+    movq %rdi, SAVED_SP
+    movq %rsi, SAVED_USP
+    pushq %rdx
+    movq $C_LAB(sys_syspr), %rdi
+    movq %rsp, %rsi
+    call pop_call
+    addq $8, %rsp
+    ret
+    .align  16
+
 	.data
 
 #_IF CHECK_BREAK
 
 ;;; SAVE_CURBRK:
 ;;;	Saves the break value across an external call
-
+        .align 8
 save_curbrk:
-	.long	0
+	.quad	0
 
 #_ENDIF
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/afloat.s v15.6301-amd64/pop/src/afloat.s
--- v15.63/pop/src/afloat.s	1997-11-18 05:22:30.000000000 -0500
+++ v15.6301-amd64/pop/src/afloat.s	2005-03-11 05:30:39.000000000 -0500
@@ -17,13 +17,13 @@
 
 	;;; User stack pointer
 
-	USP	= "ebx",
+	USP	= "rbx",
 
 	;;; Pop ddecimal structure fields:
 	;;; _DD_1 = MS part, _DD_2 = LS part
 
 	_DD_1	= @@DD_1,
-	_DD_2	= @@DD_2,
+;;;	_DD_2	= @@DD_2,
 
 );
 
@@ -34,10 +34,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -46,9 +46,9 @@
 	.data
 
 CW:	;;; For changing the control word
-	.long	0
+	.quad	0
 WORK:
-	.long	0, 0
+	.quad	0, 0
 
 	.text
 
@@ -75,7 +75,7 @@
 	fldcw	CW
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === MOVEMENT AND TYPE CONVERSION ==================================
@@ -92,19 +92,17 @@
 
 DEF_C_LAB (_pfcopy)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	addl	$8, %USP
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	addq	$16, %USP
 
-	;;; Move the double float in two longword slices
+	;;; Do the move
 
-	movl	(%esi), %eax
-	movl	%eax, (%edi)
-	movl	4(%esi), %eax
-	movl	%eax, 4(%edi)
+	movq	(%rsi), %rax
+	movq	%rax, (%rdi)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_SFLOAT_DEC:
 ;;;	Float a pop decimal.
@@ -114,10 +112,11 @@
 
 DEF_C_LAB (_pf_sfloat_dec)
 
-	decl	(%USP)
+;;;	decl	(%USP)
+        decq    (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_DFLOAT_INT:
 ;;;	Double float a system integer.
@@ -131,14 +130,14 @@
 
 DEF_C_LAB (_pf_dfloat_int)
 
-	movl	(%USP), %edi
-	fildl	4(%USP)
-	addl	$8, %USP
-	fstpl	(%edi)
+	movq	(%USP), %rdi
+	fildq	8(%USP)
+	addq	$16, %USP
+	fstpl	(%rdi)
 	wait
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_DFLOAT_DEC:
 ;;;	Double float a pop decimal.
@@ -152,18 +151,20 @@
 
 DEF_C_LAB (_pf_dfloat_dec)
 
-	movl	(%USP), %edi
+	movq	(%USP), %rdi
 
 	;;; Clear the bottom tag bit of DEC before loading
 
-	decl	4(%USP)
-	flds	4(%USP)
-	addl	$8, %USP
-	fstpl	(%edi)
+        movq    8(%USP), %rax
+	decq	%rax
+;;;	fldl	8(%USP)
+	addq	$16, %USP
+;;;	fstpl	(%rdi)
+        movq    %rax, (%rdi)
 	wait
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_DFLOAT_DDEC:
 ;;;	Double float a pop ddecimal.
@@ -181,16 +182,16 @@
 	;;; Copy the low and high halves of the pop ddecimal in two
 	;;; longword moves
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	addl	$8, %USP
-	movl	_DD_2(%esi), %eax
-	movl	%eax, (%edi)
-	movl	_DD_1(%esi), %eax
-	movl	%eax, 4(%edi)
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	addq	$16, %USP
+;;;	movl	_DD_2(%esi), %eax
+;;;	movl	%eax, (%rdi)
+	movq	_DD_1(%rsi), %rax
+	movq	%rax, (%rdi)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_CVT_TO_DEC:
 ;;;	Convert a machine double float to a pop decimal.
@@ -213,13 +214,14 @@
 
 	;;; Load the double float to EDX:EAX
 
-	movl	(%USP), %esi
-	movl	(%esi), %eax
-	movl	4(%esi), %edx
+	movq	(%USP), %rsi
+	movq	(%rsi), %rax
+;;;	movl	4(%esi), %edx
 
 	;;; Set bits in the low word to force rounding of 22nd bit of
 	;;; mantissa except where 'tied' and 21st bit is 0 (even)
 
+#_IF false
 	cmpl	$0x40000000, %eax
 	je	L1.1
 	orl	$0x38000000, %eax
@@ -243,8 +245,19 @@
 	movl	WORK, %eax
 	andb	$0xfc, %al
 	orb	$1, %al
-	movl	%eax, (%USP)
+#_ENDIF
+        andq    $-3, %rax
+        orq     $1, %rax
+	movq	%rax, (%USP)
+        shrq    $32, %rax
+        testl   $D_EXP, %eax
+        jz      L1.2
+        ret
+L1.2:
+        movq    $1, (%USP)
+        ret
 
+#_IF false
 	;;; Now check for overflow/underflow by examining the exponent of
 	;;; the result
 
@@ -274,8 +287,8 @@
 
 	movl	$C_LAB(false), (%USP)
 	ret
-
-	.align	4
+#_ENDIF
+	.align  16
 
 ;;; _PF_CVT_TO_DDEC:
 ;;;	Convert machine double float to pop ddecimal, converting -0.0 and
@@ -291,17 +304,21 @@
 
 DEF_C_LAB (_pf_cvt_to_ddec)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %esi
-	addl	$8, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rsi
+	addq	$16, %USP
 
 	;;; Load high part of dfloat.
 	;;; Test the exponent for zero (implies zero or denormal)
 
-	movl	4(%esi), %eax
+	movq	(%rsi), %rax
+        movq    %rax, _DD_1(%rdi)
+        shrq    $32, %rax
 	testl	$D_EXP, %eax
 	jz	L1.3
+        ret
 
+#_IF false
 	;;; Non-zero number: store high and low halves in the pop structure
 	;;; and return
 
@@ -310,13 +327,13 @@
 	movl	%eax, _DD_2(%edi)
 	ret
 
+#_ENDIF
 L1.3:	;;; Zero or denormal: make the pop ddecimal really zero
 
-	movl	$0, _DD_1(%edi)
-	movl	$0, _DD_2(%edi)
+	movq	$0, _DD_1(%rdi)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_ROUND_D_TO_S:
 ;;;	Round a machine double float to a single float. The double float
@@ -334,29 +351,29 @@
 
 	;;; Load the argument to the 387 as a double and store as a single
 
-	movl	(%USP), %esi
-	fldl	(%esi)
-	fstps	(%esi)
+	movq	(%USP), %rsi
+	fldl	(%rsi)
+	fstps	(%rsi)
 	wait
 
 	;;; Examine the result for infinity/NaN: return <false> if so
 
-	movl	(%esi), %eax
+	movl	(%rsi), %eax
 	andl	$S_EXP, %eax
 	cmpl	$S_EXP, %eax
 	je	L1.4
 
 	;;; Result OK: return <true>
 
-	movl	$C_LAB(true), (%USP)
+	movq	$C_LAB(true), (%USP)
 	ret
 
 L1.4:	;;; Overflow: return <false>
 
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_EXTEND_S_TO_D:
 ;;;	Extend a machine single float to a double float. The argument
@@ -374,8 +391,8 @@
 
 DEF_C_LAB (_pf_extend_s_to_d)
 
-	movl	(%USP), %esi
-	movl	(%esi), %eax
+	movq	(%USP), %rsi
+	movl	(%rsi), %eax
 
 	;;; Check exponent for Inf or NaN
 
@@ -385,17 +402,17 @@
 
 	;;; OK -- do the conversion
 
-	flds	(%esi)		;;; Load as single
-	fstpl	(%esi)		;;; Store as double
+	flds	(%rsi)		;;; Load as single
+	fstpl	(%rsi)		;;; Store as double
 	wait
 	ret
 
 L1.5:	;;; Inf or NaN -- return <false>
 
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_CHECK_D:
 ;;;	Check double float for Inf or NaN.
@@ -410,16 +427,16 @@
 
 DEF_C_LAB(_pf_check_d)
 
-	movl	(%USP), %esi
-	movl	4(%esi), %eax
+	movq	(%USP), %rsi
+	movl	4(%rsi), %eax
 	andl	$D_EXP, %eax
 	cmpl	$D_EXP, %eax
 	je	L1.6
 	ret
-L1.6:	movl	$C_LAB(false), (%USP)
+L1.6:	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === DISSECTING FLOATS =============================================
@@ -445,8 +462,8 @@
 	;;; Get the address of the dfloat argument in ESI and load the
 	;;; argument to the 387
 
-	movl	(%USP), %esi
-	fldl	(%esi)
+	movq	(%USP), %rsi
+	fldl	(%rsi)
 
 	;;; Change the rounding mode of the 387 to "chop" by setting bits
 	;;; 10 & 11 of the control word
@@ -462,31 +479,31 @@
 	;;; guard the operation with an exception handler which will catch
 	;;; any 'Invalid Operation' exception arising from the store
 
-	movl	$pf_intof_exception, EXTERN_NAME(__pop_fpe_handler)
-	fistpl	(%USP)
+	movq	$pf_intof_exception, EXTERN_NAME(__pop_fpe_handler)
+	fistpq	(%USP)
 	wait				;;; Flushes out any exceptions
-	movl	$0, EXTERN_NAME(__pop_fpe_handler)
+	movq	$0, EXTERN_NAME(__pop_fpe_handler)
 
 	;;; Restore the original control word and return <true>
 
 	fldcw	CW
-	subl	$4, %USP
-	movl	$C_LAB(true), (%USP)
+	subq	$8, %USP
+	movq	$C_LAB(true), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 pf_intof_exception:
 
 	;;; Invalid operation exception - value too big for an integer store.
 	;;; Reset the FPU and return <false> to indicate overflow.
 
-	movl	$0, EXTERN_NAME(__pop_fpe_handler)
+	movq	$0, EXTERN_NAME(__pop_fpe_handler)
 	call	fpu_init
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFMODF:
 ;;;	Extract integer and fractional parts of a double float (both parts
@@ -508,15 +525,15 @@
 
 DEF_C_LAB (_pfmodf)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	addl	$8, %USP
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	addq	$16, %USP
 
 	;;; Load the source dfloat to ST and truncate to an integer:
 	;;; this means changing the rounding mode to "chop" by setting
 	;;; bits 10 & 11 of the control word
 
-	fldl	(%esi)
+	fldl	(%rsi)
 	fstcw	CW
 	wait
 	movw	CW, %ax
@@ -533,17 +550,17 @@
 	;;; Reverse-subtract the original value to leave fractional part
 	;;; in ST
 
-	fsubrl	(%esi)
+	fsubrl	(%rsi)
 
 	;;; Store results
 
-	fstpl	(%edi)
-	fstpl	(%esi)
+	fstpl	(%rdi)
+	fstpl	(%rsi)
 
 	wait
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PF_EXPOF:
 ;;;	Get and set the exponent, E, of a double float, where E is the
@@ -565,8 +582,8 @@
 
 	;;; Load high part of argument to EAX
 
-	movl	(%USP), %esi
-	movl	4(%esi), %eax
+	movq	(%USP), %rsi
+	movl	4(%rsi), %eax
 
 	;;; Mask out everything except the exponent and shift it to the
 	;;; bottom of EAX
@@ -577,28 +594,29 @@
 	;;; Unbias the exponent by subtracting 1022 and return
 
 	subl	$1022, %eax
-	movl	%eax, (%USP)
+        movslq  %eax, %rsi
+	movq	%rsi, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB(-> _pf_expof)
 
 	;;; Load high part of the argument to EAX, new exponent to ECX
 
-	movl	(%USP), %esi
-	movl	4(%esi), %eax
-	movl	4(%USP), %ecx
-	addl	$4, %USP
+	movq	(%USP), %rsi
+	movl	4(%rsi), %eax
+	movq	8(%USP), %rcx
+	addq	$8, %USP
 
 	;;; Bias the exponent by adding 1022: check it's in the 11-bit
 	;;; range 0 - 2047 and return <false> if not.
 	;;; Shift it up to the correct place in the word
 
-	addl	$1022, %ecx
-	cmpl	$2047, %ecx
+	addq	$1022, %rcx
+	cmpq	$2047, %rcx
 	ja	L1.7
-	shll	$20, %ecx
+	shlq	$20, %rcx
 
 	;;; Mask out the exponent from EAX and OR in the new one;
 	;;; store it back to the argument and return <true>
@@ -609,16 +627,16 @@
 	andl	$-1!D_EXP, %eax
 #_ENDIF
 	orl	%ecx, %eax
-	movl	%eax, 4(%esi)
-	movl	$C_LAB(true), (%USP)
+	movl	%eax, 4(%rsi)
+	movq	$C_LAB(true), (%USP)
 	ret
 
 L1.7:	;;; New exponent out of range: return <false>
 
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === PREDICATES ON DOUBLE FLOATS ===================================
@@ -633,21 +651,21 @@
 
 	;;; Get the dfloat address in ESI
 
-	movl	(%USP), %esi
+	movq	(%USP), %rsi
 
 	;;; Test all but the sign bit of the high word for zero
 
-	testl	$0x7fffffff, 4(%esi)
+	testl	$0x7fffffff, 4(%rsi)
 	jnz	L1.8
 
 	;;; Test the low word for zero
 
-	cmpl	$0, (%esi)
+	cmpl	$0, (%rsi)
 	je	return_true
-L1.8:	movl	$C_LAB(false), (%USP)
+L1.8:	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFNEG:
 ;;;	Test a machine double float for genuine negative (not -0.0).
@@ -659,8 +677,8 @@
 
 	;;; Get the dfloat address in ESI and the high word in EAX
 
-	movl	(%USP), %esi
-	movl	4(%esi), %eax
+	movq	(%USP), %rsi
+	movl	4(%rsi), %eax
 
 	;;; Test the sign bit: return <false> if not set
 
@@ -671,12 +689,12 @@
 
 	testl	$0x7fffffff, %eax
 	jnz	return_true
-	cmpl	$0, (%esi)
+	cmpl	$0, (%rsi)
 	jne	return_true
-L1.9:	movl	$C_LAB(false), (%USP)
+L1.9:	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFEQ:
 ;;;	Test two double floats for identity.
@@ -688,25 +706,23 @@
 
 	;;; Load addresses to ESI/EDI
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	addl	$4, %USP
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	addq	$8, %USP
 
 	;;; Compare high words
 
-	movl	4(%esi), %eax
-	cmpl	%eax, 4(%edi)
+	movq	(%rsi), %rax
+	cmpq	%rax, (%rdi)
 	jne	L1.10
 
 	;;; Compare low words
 
-	movl	(%esi), %eax
-	cmpl	%eax, (%edi)
 	je	return_true
-L1.10:	movl	$C_LAB(false), (%USP)
+L1.10:	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFSGR:
 ;;; _PFSGREQ:
@@ -732,7 +748,7 @@
 	movw	$0x4100, %cx
 	jmp	pfcmp
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_pfsgr)
 
@@ -745,11 +761,11 @@
 
 	;;; Load DFLOAT1 into ST(1) and DFLOAT2 into ST(0).
 
-	movl	4(%USP), %esi
-	fldl	(%esi)
-	movl	(%USP), %esi
-	fldl	(%esi)
-	addl	$4, %USP
+	movq	8(%USP), %rsi
+	fldl	(%rsi)
+	movq	(%USP), %rsi
+	fldl	(%rsi)
+	addq	$8, %USP
 
 	;;; Compare and pop ST(0) & ST(1). Transfer the flags to AX.
 
@@ -760,17 +776,17 @@
 
 	testw	%cx, %ax
 	jnz	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 return_true:
 
-	movl	$C_LAB(true), (%USP)
+	movq	$C_LAB(true), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === FLOATING POINT ARITHMETIC =====================================
@@ -783,15 +799,15 @@
 
 DEF_C_LAB (_pfabs)
 
-	movl	(%USP), %esi
-	addl	$4, %USP
+	movq	(%USP), %rsi
+	addq	$8, %USP
 
 	;;; Clear the sign bit in the high word of the argument
 
-	andl	$0x7fffffff, 4(%esi)
+	andl	$0x7fffffff, 4(%rsi)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFNEGATE:
 ;;;	Negate a double float.
@@ -801,15 +817,15 @@
 
 DEF_C_LAB (_pfnegate)
 
-	movl	(%USP), %esi
-	addl	$4, %USP
+	movq	(%USP), %rsi
+	addq	$8, %USP
 
 	;;; Complement the sign bit in the high word of the argument
 
-	btcl	$31, 4(%esi)
+	btcl	$31, 4(%rsi)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFADD:
 ;;; _PFSUB:
@@ -831,84 +847,84 @@
 
 DEF_C_LAB (_pfadd)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	fldl	(%edi)
-	faddl	(%esi)
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	fldl	(%rdi)
+	faddl	(%rsi)
 	jmp	overflow_check
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_pfsub)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	fldl	(%edi)
-	fsubl	(%esi)
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	fldl	(%rdi)
+	fsubl	(%rsi)
 	jmp	overflow_check
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_pfmult)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	fldl	(%edi)
-	fmull	(%esi)
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	fldl	(%rdi)
+	fmull	(%rsi)
 	jmp	overflow_check
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_pfdiv)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %edi
-	fldl	(%edi)
+	movq	(%USP), %rsi
+	movq	8(%USP), %rdi
+	fldl	(%rdi)
 
 	;;; Guard the division with an exception handler to catch
 	;;; any invalid operation exceptions (for 0.0/0.0)
 
-	movl	$pfdiv_exception, EXTERN_NAME(__pop_fpe_handler)
-	fdivl	(%esi)
+	movq	$pfdiv_exception, EXTERN_NAME(__pop_fpe_handler)
+	fdivl	(%rsi)
 	wait				;;; Flush any exceptions
-	movl	$0, EXTERN_NAME(__pop_fpe_handler)
+	movq	$0, EXTERN_NAME(__pop_fpe_handler)
 
 overflow_check:
 
 	;;; Pop result from ST(0) back to DFLOAT1 and pop the user stack
 
-	fstpl	(%edi)
-	addl	$4, %USP
+	fstpl	(%rdi)
+	addq	$8, %USP
 	wait
 
 	;;; Load high word of result and check for exponent all 1's
 	;;; (implies infinity/NaN). If OK, return <true>.
 
-	movl	4(%edi), %eax
+	movl	4(%rdi), %eax
 	andl	$D_EXP, %eax
 	cmpl	$D_EXP, %eax
 	je	L1.11
-	movl	$C_LAB(true), (%USP)
+	movq	$C_LAB(true), (%USP)
 	ret
 
 L1.11:	;;; Overflow: return <false>
 
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align 4
+	.align  16
 
 pfdiv_exception:
 
 	;;; Invalid operation: reset the FPU and return false
 
-	movl	$0, EXTERN_NAME(__pop_fpe_handler)
+	movq	$0, EXTERN_NAME(__pop_fpe_handler)
 	call	fpu_init
-	addl	$4, %USP
-	movl	$C_LAB(false), (%USP)
+	addq	$8, %USP
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PFQREM:
 ;;;	Divide two double floats and return quotient and remainder.
@@ -918,7 +934,7 @@
 
 	jmp	XC_LAB(Sys$-Float_qrem)
 
-	.align	4
+	.align  16
 
 
 /***************** end labels for wrapping structures *****************/
